import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import React from 'react';
import PropTypes from 'prop-types';
import Fonts from './Fonts';
import GlobalStyles from './GlobalStyles';
import theme from './theme';
import Pane from './Pane';

var App = function App(_ref) {
  var children = _ref.children,
      reset = _ref.reset,
      fonts = _ref.fonts,
      globalStyles = _ref.globalStyles,
      props = _objectWithoutProperties(_ref, ['children', 'reset', 'fonts', 'globalStyles']);

  return React.createElement(
    Pane,
    _extends({ className: 'UIApp', minHeight: '100%', width: '100%', display: 'flex', flexAuto: true, flexDirection: 'column' }, props),
    fonts,
    globalStyles,
    children
  );
};

App.propTypes = {
  children: PropTypes.any,
  reset: PropTypes.element,
  fonts: PropTypes.element,
  globalStyles: PropTypes.element
};

App.defaultProps = {
  fonts: React.createElement(Fonts, null),
  globalStyles: React.createElement(GlobalStyles, { theme: theme })
};

export default App;