import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _extends from 'babel-runtime/helpers/extends';
import React from 'react';
import Pane from './Pane';
import { css } from 'glamor';
import SyntaxHighlighter, { registerLanguage } from 'react-syntax-highlighter/dist/light';
import docco from 'react-syntax-highlighter/dist/styles/docco';
import gradle from 'react-syntax-highlighter/dist/languages/gradle';
import java from 'react-syntax-highlighter/dist/languages/java';
import javascript from 'react-syntax-highlighter/dist/languages/javascript';
import objectivec from 'react-syntax-highlighter/dist/languages/objectivec';
import xml from 'react-syntax-highlighter/dist/languages/xml';
import theme from './theme';
var minorScale = theme.minorScale,
    majorScale = theme.majorScale;


registerLanguage('gradle', gradle);
registerLanguage('java', java);
registerLanguage('javascript', javascript);
registerLanguage('objectivec', objectivec);
registerLanguage('xml', xml);

var segmentStyle = _extends({}, docco, {
  hljs: _extends({}, docco.hljs, {
    background: 'transparent',
    padding: majorScale(1) + ' ' + minorScale(3)
  })
});

var styles = {
  '& > pre': {
    margin: 0
  }
};

var CodeBlock = function CodeBlock(_ref) {
  var children = _ref.children,
      codeStyle = _ref.codeStyle,
      language = _ref.language,
      style = _ref.style,
      props = _objectWithoutProperties(_ref, ['children', 'codeStyle', 'language', 'style']);

  return React.createElement(
    Pane,
    _extends({}, css(styles), props),
    React.createElement(
      SyntaxHighlighter,
      { language: language, style: codeStyle },
      children
    )
  );
};

CodeBlock.propTypes = _extends({}, Pane.propTypes, SyntaxHighlighter.propTypes);

CodeBlock.defaultProps = {
  overflow: 'hidden',
  textAlign: 'left',
  tint: true,
  rounded: true,
  border: true,
  textStyle: 'mono',
  language: 'javascript',
  codeStyle: segmentStyle
};

export default CodeBlock;