import _Object$keys from 'babel-runtime/core-js/object/keys';
import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import React from 'react';
import PropTypes from 'prop-types';
import Box from './Box';
import theme from './theme';
var majorScale = theme.majorScale;
var minorScale = theme.minorScale;


var IconSize = {
  mini: minorScale(3),
  small: majorScale(2),
  big: majorScale(3)
};

var Icon = function Icon(_ref) {
  var size = _ref.size,
      props = _objectWithoutProperties(_ref, ['size']);

  var realSize = IconSize.hasOwnProperty(size) ? IconSize[size] : size;

  return React.createElement(Box, _extends({ is: 'span', width: realSize, height: realSize }, props));
};

Icon.propTypes = {
  size: PropTypes.oneOfType([PropTypes.string, PropTypes.oneOf(_Object$keys(IconSize))]),
  fill: PropTypes.string
};

Icon.defaultProps = {
  size: 'mini',
  fill: 'currentColor',
  stroke: 'currentColor',
  display: 'inline-block'
};

export default Icon;