import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _Number$isInteger from 'babel-runtime/core-js/number/is-integer';
import React from 'react';
import PropTypes from 'prop-types';
import Box from './Box';
import theme from './theme';

var getValue = function getValue(val) {
  return _Number$isInteger(val) ? val : '';
};

var parseShorthand = function parseShorthand(_ref) {
  var dark = _ref.dark,
      tint = _ref.tint,
      white = _ref.white;

  if (white) return { background: 'white' };
  if (tint) return { background: 'tint' + getValue(tint) };
  if (dark) return { background: 'dark' };
  return {};
};

var Pane = function Pane(_ref2) {
  var dark = _ref2.dark,
      tint = _ref2.tint,
      white = _ref2.white,
      props = _objectWithoutProperties(_ref2, ['dark', 'tint', 'white']);

  return React.createElement(Box, _extends({}, parseShorthand({ dark: dark, tint: tint, white: white }), props));
};

Pane.propTypes = _extends({}, Box.propTypes, {
  dark: PropTypes.bool,
  tint: PropTypes.oneOfType([PropTypes.bool, PropTypes.oneOf([1, 2])]),
  white: PropTypes.bool
});

Pane.displayName = 'Pane';

Pane.defaultProps = {
  theme: theme
};

export default Pane;