import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import React from 'react';
import { css } from 'glamor';
import Pane from './Pane';
import Text from './Text';
import Link from './Link';
import Triangle from './Triangle';
import theme from './theme';
var minorScale = theme.minorScale,
    majorScale = theme.majorScale;


var SidebarLink = function SidebarLink(_ref) {
  var children = _ref.children,
      active = _ref.active,
      props = _objectWithoutProperties(_ref, ['children', 'active']);

  return React.createElement(
    Link,
    _extends({ textStyle: 'body1' }, css({
      '&:hover, &.active': {
        backgroundColor: theme.rawColors.blue50
      }
    }), { active: active }, props),
    React.createElement(
      Text,
      { is: 'span', flexAuto: true },
      children
    ),
    active ? React.createElement(Triangle, { aim: 'right', fill: theme.intent.secondary.active.linkColor }) : null
  );
};

SidebarLink.defaultProps = {
  is: 'a',
  secondary: true,
  display: 'flex',
  alignItems: 'center',
  paddingX: majorScale(1),
  paddingY: minorScale(1),
  marginBottom: minorScale(1),
  rounded: true
};

var Sidebar = function Sidebar(props) {
  return React.createElement(Pane, props);
};

Sidebar.defaultProps = {
  white: true,
  borderRight: true,
  width: majorScale(30),
  padding: majorScale(2),
  flex: '0 0 auto'
};

export { Sidebar, SidebarLink };