import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import React from 'react';
import Icon from './Icon';
import theme from './theme';

var SuccessAlertIcon = function SuccessAlertIcon(_ref) {
  var fill = _ref.fill,
      props = _objectWithoutProperties(_ref, ['fill']);

  return React.createElement(
    Icon,
    props,
    React.createElement(
      'svg',
      { style: { display: 'block' }, width: '100%', height: '100%', viewBox: '0 0 16 16' },
      React.createElement('path', { fill: fill, fillRule: 'evenodd', d: 'M8 0C3.589 0 0 3.589 0 8s3.589 8 8 8 8-3.589 8-8-3.589-8-8-8zm0 14c-3.309 0-6-2.691-6-6s2.691-6 6-6 6 2.691 6 6-2.691 6-6 6zm-1-2.586L12.414 6 11 4.586l-4 4-2-2L3.586 8 7 11.414z' })
    )
  );
};

SuccessAlertIcon.propTypes = _extends({}, Icon.propTypes);

SuccessAlertIcon.defaultProps = _extends({}, Icon.defaultProps, {
  size: 'small',
  fill: theme.colors.success
});

export default SuccessAlertIcon;