import _Object$assign from 'babel-runtime/core-js/object/assign';
import React from 'react';
import PropTypes from 'prop-types';
import Spinner from './Spinner';
import theme from './theme';
var majorScale = theme.majorScale;


var defaultSpinnerProps = {
  marginX: 'auto',
  marginY: majorScale(8)
};

export default function (ComposedComponent, spinnerProps) {
  spinnerProps = _Object$assign({}, defaultSpinnerProps, spinnerProps);
  var componentName = ComposedComponent.displayName || ComposedComponent.name || 'Unknown';

  function withLoader(props) {
    return props.isLoading ? React.createElement(Spinner, spinnerProps) : React.createElement(ComposedComponent, props);
  }

  withLoader.displayName = 'withLoader(' + componentName + ')';

  withLoader.propTypes = {
    isLoading: PropTypes.bool.isRequired
  };

  return withLoader;
}