import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _extends from 'babel-runtime/helpers/extends';
import _Object$keys from 'babel-runtime/core-js/object/keys';
import PropTypes from 'prop-types';
import { css } from 'glamor';
import cx from 'classnames';
import theme from '../components/theme';

export var propTypes = {
  background: PropTypes.oneOf(_Object$keys(theme.backgrounds)),
  interactive: PropTypes.bool
};

var parseBackground = function parseBackground(val, interactive) {
  if (theme.backgrounds.hasOwnProperty(val)) {
    var bg = theme.backgrounds[val];
    return css(_extends({
      color: bg.textColor,
      backgroundColor: bg.backgroundColor,
      borderColor: bg.borderColor + ' !important'
    }, interactive ? {
      '&:hover, &:active': {
        borderColor: bg.borderColorInteractive + ' !important'
      }
    } : {}));
  }
};

var parseProps = function parseProps(_ref) {
  var background = _ref.background,
      interactive = _ref.interactive,
      className = _ref.className,
      props = _objectWithoutProperties(_ref, ['background', 'interactive', 'className']);

  return _extends({
    className: background !== undefined ? cx('' + parseBackground(background, interactive), className) : className
  }, props);
};
export { parseProps };