import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import PropTypes from 'prop-types';
import { css } from 'glamor';
import cx from 'classnames';

export var propTypes = {
  flex: PropTypes.string,
  flexAuto: PropTypes.bool,
  flexNone: PropTypes.bool,
  flexColumn: PropTypes.bool,
  flexWrap: PropTypes.bool,
  alignItems: PropTypes.oneOf(['stretch', 'center', 'baseline', 'flex-start', 'flex-end']),
  justifyContent: PropTypes.oneOf(['center', 'space-around', 'space-between', 'flex-start', 'flex-end']),
  flexDirection: PropTypes.oneOf(['row', 'row-reverse', 'column', 'column-reverse']),
  flexGrow: PropTypes.string,
  flexShrink: PropTypes.string
};

var getFlex = function getFlex(_ref) {
  var flex = _ref.flex,
      flexAuto = _ref.flexAuto,
      flexNone = _ref.flexNone;

  if (flexAuto) return { flex: 'auto' };
  if (flexNone) return { flex: 'none' };
  if (flex) return { flex: flex };
  return {};
};

var getFlexDirection = function getFlexDirection(_ref2) {
  var flexColumn = _ref2.flexColumn,
      flexDirection = _ref2.flexDirection;

  if (flexColumn) return { flexDirection: 'column' };
  if (flexDirection) return { flexDirection: flexDirection };
  return {};
};

var getFlexWrap = function getFlexWrap(_ref3) {
  var flexWrap = _ref3.flexWrap;

  if (flexWrap) return { flexWrap: 'wrap' };
  return {};
};

var parseProps = function parseProps(_ref4) {
  var flex = _ref4.flex,
      flexAuto = _ref4.flexAuto,
      flexNone = _ref4.flexNone,
      flexColumn = _ref4.flexColumn,
      flexDirection = _ref4.flexDirection,
      flexWrap = _ref4.flexWrap,
      alignItems = _ref4.alignItems,
      justifyContent = _ref4.justifyContent,
      flexShrink = _ref4.flexShrink,
      flexGrow = _ref4.flexGrow,
      className = _ref4.className,
      props = _objectWithoutProperties(_ref4, ['flex', 'flexAuto', 'flexNone', 'flexColumn', 'flexDirection', 'flexWrap', 'alignItems', 'justifyContent', 'flexShrink', 'flexGrow', 'className']);

  if (flex !== undefined || flexAuto !== undefined || flexNone !== undefined || flexColumn !== undefined || flexDirection !== undefined || flexWrap !== undefined || alignItems !== undefined || justifyContent !== undefined || flexShrink !== undefined || flexGrow !== undefined) {
    return _extends({
      className: cx(className, '' + css(_extends({}, getFlex({ flex: flex, flexAuto: flexAuto, flexNone: flexNone }), getFlexDirection({ flexColumn: flexColumn, flexDirection: flexDirection }), getFlexWrap({ flexWrap: flexWrap }), alignItems ? { alignItems: alignItems } : {}, justifyContent ? { justifyContent: justifyContent } : {}, flexShrink ? { flexShrink: flexShrink } : {}, flexGrow ? { flexGrow: flexGrow } : {})))
    }, props);
  }

  return _extends({ className: className }, props);
};
export { parseProps };