import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _Number$isInteger from 'babel-runtime/core-js/number/is-integer';
import PropTypes from 'prop-types';
import { css } from 'glamor';
import cx from 'classnames';
import theme from '../components/theme';

export var propTypes = {
  shadow: PropTypes.oneOfType([PropTypes.bool, PropTypes.oneOf(theme.shadows.map(function (_, i) {
    return i;
  }))])
};

var parseShadow = function parseShadow(val) {
  var i = _Number$isInteger(val) ? val - 1 : 0;
  return css({
    boxShadow: theme.shadows[i]
  });
};

var parseProps = function parseProps(_ref) {
  var shadow = _ref.shadow,
      className = _ref.className,
      props = _objectWithoutProperties(_ref, ['shadow', 'className']);

  return _extends({
    className: shadow !== undefined ? cx('' + parseShadow(shadow), className) : className
  }, props);
};
export { parseProps };