import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _extends from 'babel-runtime/helpers/extends';
import _Object$keys from 'babel-runtime/core-js/object/keys';
import PropTypes from 'prop-types';
import { css } from 'glamor';
import cx from 'classnames';
import theme from './../components/theme';

export var propTypes = {
  textStyle: PropTypes.oneOf(_Object$keys(theme.textStyles)),
  bold: PropTypes.bool,
  textColor: PropTypes.oneOf(_Object$keys(theme.textColors))
};

var getTextStyle = function getTextStyle(_ref, textStyle) {
  var fontSize = _ref.fontSize,
      fontWeight = _ref.fontWeight,
      lineHeight = _ref.lineHeight,
      letterSpacing = _ref.letterSpacing,
      textTransform = _ref.textTransform,
      fontFamily = _ref.fontFamily,
      color = _ref.color;
  return {
    '&, & .ui-lib-box:not(.ui-lib-has-text-style)': _extends({}, fontSize ? { fontSize: fontSize } : {}, fontWeight ? { fontWeight: fontWeight } : {}, lineHeight ? { lineHeight: lineHeight } : {}, letterSpacing ? { letterSpacing: letterSpacing } : {}, textTransform ? { textTransform: textTransform } : {}, fontFamily ? { fontFamily: fontFamily } : {}, color ? { color: color } : {})
  };
};

var getClassName = function getClassName(_ref2) {
  var textStyle = _ref2.textStyle;
  return css(_extends({}, textStyle ? getTextStyle(theme.textStyles[textStyle], textStyle) : {}));
};

var parseProps = function parseProps(_ref3) {
  var textStyle = _ref3.textStyle,
      textColor = _ref3.textColor,
      bold = _ref3.bold,
      className = _ref3.className,
      props = _objectWithoutProperties(_ref3, ['textStyle', 'textColor', 'bold', 'className']);

  if (textStyle !== undefined || bold !== undefined || textColor !== undefined) {
    return _extends({
      className: cx('' + getClassName({ textStyle: textStyle, bold: bold }), bold && '' + css({ fontWeight: '500' }), textColor && '' + css({ color: theme.textColors[textColor] }), textStyle !== undefined && 'ui-lib-has-text-style', className)
    }, props);
  }
  return _extends({ className: className }, props);
};
export { parseProps };