import React from 'react';
import { storiesOf } from '@storybook/react';
import { App, Pane, NavigationBar, Avatar, Box, Triangle, theme } from '../components';
import Content from './Content';
var majorScale = theme.majorScale;


var AvatarWithTriangle = function AvatarWithTriangle() {
  return React.createElement(
    Box,
    { display: 'inline-flex', alignItems: 'center' },
    React.createElement(
      Avatar,
      { marginLeft: majorScale(1), marginRight: majorScale(1), src: '', imageSize: 'small' },
      'Segment Sloth'
    ),
    React.createElement(Triangle, { aim: 'down', display: 'inline-flex', fill: 'white' })
  );
};

export default function navigationBarStory(module) {
  storiesOf('Navigation Bar', module).add('usage', function () {
    return React.createElement(
      App,
      null,
      React.createElement(
        Pane,
        { white: true, padding: majorScale(10) },
        React.createElement(
          Content,
          { markdown: true },
          '\n# Navigation Bar\n\nThe NavigationBar component. Composes `<Pane />`.\n\n```\nconst AvatarWithTriangle = () =>\n  <Box display=\'inline-flex\' alignItems=\'center\'>\n    <Avatar marginLeft={majorScale(1)} marginRight={majorScale(1)} src=\'\' imageSize=\'small\'>Segment Sloth</Avatar>\n    <Triangle aim=\'down\'  display=\'inline-flex\' fill=\'white\' />\n  </Box>\n\n<NavigationBar left={\'Sloth Corp Media\'} right={<AvatarWithTriangle />}>Workspaces</NavigationBar>\n```\n\n'
        ),
        React.createElement(
          NavigationBar,
          { left: 'Sloth Corp Media', right: React.createElement(AvatarWithTriangle, null) },
          'Workspaces'
        ),
        React.createElement(
          Content,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`children` | node/string | undefined | if string wrapped in `<NavigationBarTitle />`\n`left` | node | undefined | optional component next to logo\n`right` | node | undefined | optional component in right corner\n`logo`| node | `<NavigationBarLogo />` | formatted Segment logo\n`height`| string | 58px | formatted Segment logo\n'
        )
      )
    );
  }).add('with title only', function () {
    return React.createElement(
      NavigationBar,
      null,
      'Workspaces'
    );
  }).add('with title and left component', function () {
    return React.createElement(
      NavigationBar,
      { left: 'Sloth Corp Media' },
      'Workspaces'
    );
  }).add('with title and right component', function () {
    return React.createElement(
      NavigationBar,
      { right: React.createElement(AvatarWithTriangle, null) },
      'Workspaces'
    );
  }).add('with title and left + right component', function () {
    return React.createElement(
      NavigationBar,
      { left: 'Sloth Corp Media', right: React.createElement(AvatarWithTriangle, null) },
      'Workspaces'
    );
  });
}