import React from 'react';
import { storiesOf } from '@storybook/react';
import { App, SearchInput, Pane, theme } from '../components';
import Content from './Content';
var minorScale = theme.minorScale,
    majorScale = theme.majorScale;


export default function inputStory(module) {
  storiesOf('Search Input', module).add('usage', function () {
    return React.createElement(
      App,
      { white: true },
      React.createElement(
        Pane,
        { white: true, padding: majorScale(10) },
        React.createElement(
          Content,
          { markdown: true },
          '\n# SearchInput\n\nThe SearchInput component is an `input` element. Implement the `<Box />` component.\n\n```\n<SearchInput marginY={majorScale(2)} placeholder=\'Type to search\u2026\' />\n<SearchInput size=\'small\' marginY={majorScale(2)} placeholder=\'Type to search\u2026\' />\n<SearchInput disabled marginY={majorScale(2)} placeholder=\'Type to search\u2026\' />\n```\n\n'
        ),
        React.createElement(SearchInput, { marginY: majorScale(2), placeholder: 'Type to search\u2026' }),
        React.createElement(SearchInput, { size: 'small', marginY: majorScale(2), placeholder: 'Type to search\u2026' }),
        React.createElement(SearchInput, { disabled: true, marginY: majorScale(2), placeholder: 'Type to search\u2026' })
      )
    );
  }).add('standalone', function () {
    return React.createElement(SearchInput, null);
  }).add('with spacing', function () {
    return React.createElement(
      Pane,
      { white: true },
      React.createElement(SearchInput, { margin: minorScale(3) })
    );
  }).add('with width and centered', function () {
    return React.createElement(
      Pane,
      { white: true },
      React.createElement(SearchInput, { width: '240px', marginX: 'auto', marginY: minorScale(3) })
    );
  });
}