import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import React, { Component } from 'react';
import { storiesOf } from '@storybook/react';
import { App, Pane, SegmentedControl, theme } from '../components';
import Content from './Content';
var majorScale = theme.majorScale;

var SegmentedControlExample = function (_Component) {
  _inherits(SegmentedControlExample, _Component);

  function SegmentedControlExample() {
    _classCallCheck(this, SegmentedControlExample);

    var _this = _possibleConstructorReturn(this, (SegmentedControlExample.__proto__ || _Object$getPrototypeOf(SegmentedControlExample)).call(this));

    _this.options = [{ label: 'Hourly', value: 'hourly' }, { label: 'Daily', value: 'daily' }, { label: 'Monthly', value: 'monthly' }];

    _this.state = {
      value: _this.options[1].value
    };
    return _this;
  }

  _createClass(SegmentedControlExample, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var value = this.state.value;


      return React.createElement(
        Pane,
        { display: 'flex', flexDirection: 'column', alignItems: 'center' },
        React.createElement(SegmentedControl, {
          options: this.options,
          value: value,
          onChange: function onChange(value) {
            return _this2.setState({ value: value });
          },
          width: majorScale(40)
        }),
        React.createElement(
          Pane,
          { marginY: majorScale(1) },
          value
        )
      );
    }
  }]);

  return SegmentedControlExample;
}(Component);

export default function (module) {
  storiesOf('SegmentedControl', module).add('usage', function () {
    return React.createElement(
      App,
      null,
      React.createElement(
        Pane,
        { white: true, padding: majorScale(10) },
        React.createElement(
          Content,
          { markdown: true },
          '\n# SegmentedControl\n\nThe SegmentedControl component, it\'s a fancy radio. Implements `<Box />`.\n\nUses regular `input[type=radio]`\'s under the hood.\n\n```\nclass SegmentedControlExample extends Component {\n  constructor () {\n    super()\n\n    this.options = [\n      {label: \'Hourly\', value: \'hourly\'},\n      {label: \'Daily\', value: \'daily\'},\n      {label: \'Monthly\', value: \'monthly\'}\n    ]\n\n    this.state = {\n      value: this.options[1].value\n    }\n  }\n\n  render () {\n    const {value} = this.state\n\n    return (\n      <Pane display=\'flex\' flexDirection=\'column\' alignItems=\'center\'>\n        <SegmentedControl\n          options={this.options}\n          value={value}\n          onChange={(value) => this.setState({value})}\n          width={majorScale(40)}\n        />\n        <Pane marginY={majorScale(1)}>\n          {value}\n        </Pane>\n      </Pane>\n    )\n  }\n}\n```\n'
        ),
        React.createElement(SegmentedControlExample, null),
        React.createElement(
          Content,
          { markdown: true },
          '\nprop | version | type | default | description\n-----|---------|------| --------|----------\n`options`| v7.0.0 | `[ { label: node, value: string } ]` | `undefined` | array of options to render\n`size`| v7.0.0 | `default`, `small` | `default` | [optional] as defined by `theme.controlSizes`\n`name`| v7.0.0 | `string` | `SegmentedControl-*` | [optional] `name` of the `input[type=radio]`\'s\n`value`| v7.0.0 | `string` | `undefined` | [optional] sets the active option. setting this makes it a controlled input\n`defaultValue`| v7.0.0 | `string` | `undefined` | [optional] sets the default active option\n`onChange`| v7.0.0 | `function` | `undefined` | [optional] callback passed the value of the new active option\n'
        )
      )
    );
  });
}