import React from 'react';
import { storiesOf } from '@storybook/react';
import { App, Pane, Sidebar, SidebarLink, theme } from '../components';
import Content from './Content';
var majorScale = theme.majorScale;


export default function sidebarStory(module) {
  storiesOf('Sidebar', module).add('usage', function () {
    return React.createElement(
      App,
      null,
      React.createElement(
        Pane,
        { white: true, padding: majorScale(10) },
        React.createElement(
          Content,
          { markdown: true },
          '\n# Sidebar\n\nThe Sidebar component. Composes `<Pane />`.\nThe SidebarLink components. Composes `<Link />`.\n\n```\n<Sidebar>\n  <SidebarLink href=\'#\' active>Tracks</SidebarLink>\n  <SidebarLink href=\'#\'>Page</SidebarLink>\n  <SidebarLink href=\'#\'>Screen</SidebarLink>\n  <SidebarLink href=\'#\'>Identify</SidebarLink>\n  <SidebarLink href=\'#\'>Group</SidebarLink>\n</Sidebar>\n```\n\n'
        ),
        React.createElement(
          Sidebar,
          null,
          React.createElement(
            SidebarLink,
            { href: '#', active: true },
            'Tracks'
          ),
          React.createElement(
            SidebarLink,
            { href: '#' },
            'Page'
          ),
          React.createElement(
            SidebarLink,
            { href: '#' },
            'Screen'
          ),
          React.createElement(
            SidebarLink,
            { href: '#' },
            'Identify'
          ),
          React.createElement(
            SidebarLink,
            { href: '#' },
            'Group'
          )
        ),
        React.createElement(
          Content,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`children` | node | undefined | contents of Sidebar\n'
        )
      )
    );
  }).add('with Sidebar Links', function () {
    return React.createElement(
      Sidebar,
      { flexAuto: true },
      React.createElement(
        SidebarLink,
        { href: '#', active: true },
        'Tracks'
      ),
      React.createElement(
        SidebarLink,
        { href: '#' },
        'Page'
      ),
      React.createElement(
        SidebarLink,
        { href: '#' },
        'Screen'
      ),
      React.createElement(
        SidebarLink,
        { href: '#' },
        'Identify'
      ),
      React.createElement(
        SidebarLink,
        { href: '#' },
        'Group'
      )
    );
  });
}