import React from 'react';
import { storiesOf } from '@storybook/react';
import { App, Pane, SubNavigationBar, SubNavigationBarLink, theme } from '../components';
import Content from './Content';
var majorScale = theme.majorScale;


export default function subNavigationBarStory(module) {
  storiesOf('Sub Navigation Bar', module).add('usage', function () {
    return React.createElement(
      App,
      null,
      React.createElement(
        Pane,
        { white: true, padding: majorScale(10) },
        React.createElement(
          Content,
          { markdown: true },
          '\n# Sub Navigation Bar\n\nThe SubNavigationBar component. Implements `<Pane />`.\n\n```\n<SubNavigationBar left={\'Sources\'}>\n  {[\'Overview\', \'Integrations\', \'Debugger\', \'Schema\', \'Settings\'].map(name =>\n    <SubNavigationBarLink key={name} href=\'#\' active={name === \'Overview\'}>\n      {name}\n    </SubNavigationBarLink>\n  )}\n</SubNavigationBar>\n```\n\n'
        ),
        React.createElement(
          SubNavigationBar,
          { left: 'Sources' },
          ['Overview', 'Integrations', 'Debugger', 'Schema', 'Settings'].map(function (name) {
            return React.createElement(
              SubNavigationBarLink,
              { key: name, href: '#', active: name === 'Overview' },
              name
            );
          })
        ),
        React.createElement(
          Content,
          { markdown: true, marginTop: majorScale(2) },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`children` | node | undefined | optional component in center\n`left` | node/string | undefined | if string wrapped in `<SubNavigationBarTitle />`\n`right` | node | undefined | optional component in right corner\n'
        )
      )
    );
  }).add('standalone', function () {
    return React.createElement(
      SubNavigationBar,
      { left: 'Sources' },
      ['Overview', 'Integrations', 'Debugger', 'Schema', 'Settings'].map(function (name) {
        return React.createElement(
          SubNavigationBarLink,
          { key: name, href: '#', active: name === 'Overview' },
          name
        );
      })
    );
  });
}