import React from 'react';
import { storiesOf } from '@storybook/react';
import { App, Pane, Textarea, theme } from '../components';
import Content from './Content';
var majorScale = theme.majorScale;


export default function textareaStory(module) {
  storiesOf('Textarea', module).add('usage', function () {
    return React.createElement(
      App,
      { white: true },
      React.createElement(
        Pane,
        { white: true, padding: majorScale(10) },
        React.createElement(
          Content,
          { markdown: true },
          '\n# Textarea\n\n**Available since v4.1.0**\n\nThe Textarea component is an `textarea` element that implements the `<Pane />` component.\n\n```\n<Textarea placeholder=\'Let us know why\' rows=\'4\' maxWidth=\'640px\' marginY={majorScale(2)} />\n<Textarea disabled placeholder=\'Let us know why\' rows=\'4\' maxWidth=\'640px\' marginY={majorScale(2)} />\n```\n'
        ),
        React.createElement(Textarea, { placeholder: 'Let us know why', rows: '4', maxWidth: '640px', marginY: majorScale(2) }),
        React.createElement(Textarea, { disabled: true, placeholder: 'Let us know why', rows: '4', maxWidth: '640px', marginY: majorScale(2) })
      )
    );
  });
}