'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _glamor = require('glamor');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _enhancers = require('../enhancers');

var enhancers = _interopRequireWildcard(_enhancers);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var enhancersArray = Object.keys(enhancers).map(function (key) {
  return enhancers[key];
});

var propTypes = enhancersArray.reduce(function (memo, _ref) {
  var propTypes = _ref.propTypes;

  if (propTypes) memo = _extends({}, memo, propTypes);
}, {
  onRef: _propTypes2.default.func,
  is: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element, _propTypes2.default.func])
});

var parseProps = function parseProps(props) {
  return enhancersArray.reduce(function (props, _ref2) {
    var parseProps = _ref2.parseProps;

    if (parseProps) props = parseProps(props);
    return props;
  }, props);
};

var n = 'ui-lib-box';

// Add these styles globally until glamor properly supports &:matches

_glamor.css.global('article.' + n + ', aside.' + n + ', details.' + n + ', figcaption.' + n + ', figure.' + n + ', footer.' + n + ', header.' + n + ', hgroup.' + n + ', menu.' + n + ', nav.' + n + ', section.' + n, {
  display: 'block'
});

_glamor.css.global('ol.' + n + ', ul.' + n, {
  listStyle: 'none'
});

_glamor.css.global('bloquote.' + n + ', q.' + n, {
  quotes: 'none'
});

_glamor.css.global('table.' + n, {
  borderCollapse: 'collapse',
  borderSpacing: '0'
});

_glamor.css.global('input.' + n + ', textarea.' + n, {
  outline: 'none'
});

_glamor.css.global('strong.' + n, {
  fontWeight: '500'
});

_glamor.css.global('em.' + n, {
  fontStyle: 'italic'
});

_glamor.css.global('*.' + n + ', *.' + n + ':before, *.' + n + ':after', {
  boxSizing: 'border-box'
});

var cssBaseStyles = (0, _glamor.css)({
  margin: '0',
  padding: '0',
  border: '0',
  verticalAlign: 'baseline',
  MozOsxFontSmoothing: 'grayscale',
  WebkitFontSmoothing: 'antialiased',
  fontSmoothing: 'antialiased'
});

var Box = function (_React$Component) {
  _inherits(Box, _React$Component);

  function Box() {
    _classCallCheck(this, Box);

    return _possibleConstructorReturn(this, (Box.__proto__ || Object.getPrototypeOf(Box)).apply(this, arguments));
  }

  _createClass(Box, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          is = _props.is,
          theme = _props.theme,
          onRef = _props.onRef,
          restProps = _objectWithoutProperties(_props, ['is', 'theme', 'onRef']); // eslint-disable-line


      var _parseProps = parseProps(restProps),
          className = _parseProps.className,
          parsedProps = _objectWithoutProperties(_parseProps, ['className']);

      return _react2.default.createElement(is, _extends({}, parsedProps, {
        className: (0, _classnames2.default)(n, '' + cssBaseStyles, className)
      }, onRef ? {
        ref: function ref(node) {
          onRef(node);
        }
      } : {}));
    }
  }]);

  return Box;
}(_react2.default.Component);

Box.propTypes = propTypes;

Box.defaultProps = {
  is: 'div'
};

Box.displayName = 'Box';

exports.default = Box;