'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _glamor = require('glamor');

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

var _Box = require('./Box');

var _Box2 = _interopRequireDefault(_Box);

var _color = require('color');

var _color2 = _interopRequireDefault(_color);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var transparentBg = (0, _color2.default)(_theme2.default.rawColors.grey400).alpha(0).rgb().string();
var opaqueBg = (0, _color2.default)(_theme2.default.rawColors.grey400).alpha(0.8).rgb().string();

var fadeInAnimation = _glamor.css.keyframes('fadeInAnimation', {
  from: {
    backgroundColor: transparentBg
  },
  to: {
    backgroundColor: opaqueBg
  }
});

var fadeOutAnimation = _glamor.css.keyframes('fadeOutAnimation', {
  from: {
    backgroundColor: opaqueBg
  },
  to: {
    backgroundColor: transparentBg
  }
});

var mainCss = (0, _glamor.css)({
  position: 'fixed',
  zIndex: 10,
  top: 0,
  right: 0,
  bottom: 0,
  left: 0,
  background: opaqueBg,
  animationDuration: _theme2.default.animationDuration.slow,
  animationTimingFunction: _theme2.default.animationEasing.standard,
  animationFillMode: 'forwards'
});

var parseProps = function parseProps(_ref) {
  var className = _ref.className,
      fadeOut = _ref.fadeOut,
      onClick = _ref.onClick,
      onFadeEnd = _ref.onFadeEnd,
      props = _objectWithoutProperties(_ref, ['className', 'fadeOut', 'onClick', 'onFadeEnd']);

  return props;
};

var Overlay = function (_Component) {
  _inherits(Overlay, _Component);

  function Overlay() {
    _classCallCheck(this, Overlay);

    var _this = _possibleConstructorReturn(this, (Overlay.__proto__ || Object.getPrototypeOf(Overlay)).call(this));

    _this.handleClick = _this.handleClick.bind(_this);
    _this.handleAnimationEnd = _this.handleAnimationEnd.bind(_this);
    return _this;
  }

  _createClass(Overlay, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.body.style.overflow = 'hidden';
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.body.style.overflow = 'initial';
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          fadeOut = _props.fadeOut,
          children = _props.children;

      var style = {
        animationName: '' + (fadeOut ? fadeOutAnimation : fadeInAnimation)
      };

      return _react2.default.createElement(
        _Box2.default,
        _extends({}, parseProps(this.props), {
          className: '' + mainCss,
          style: style,
          onRef: function onRef(node) {
            return _this2.node = node;
          },
          onClick: this.handleClick,
          onAnimationEnd: this.handleAnimationEnd
        }),
        children
      );
    }
  }, {
    key: 'handleClick',
    value: function handleClick(e) {
      if (this.props.onClick && e.target === this.node) {
        this.props.onClick();
      }
    }
  }, {
    key: 'handleAnimationEnd',
    value: function handleAnimationEnd(e) {
      if (this.props.onFadeEnd && e.target === this.node) {
        this.props.onFadeEnd();
      }
    }
  }]);

  return Overlay;
}(_react.Component);

Overlay.propTypes = _extends({}, _Box2.default.propTypes, {
  fadeOut: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  onFadeEnd: _propTypes2.default.func
});

Overlay.defaultProps = {
  fadeOut: false
};

Overlay.displayName = 'Overlay';

exports.default = Overlay;