'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _pluralize = require('pluralize');

var _pluralize2 = _interopRequireDefault(_pluralize);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _Chevron = require('./Chevron');

var _Chevron2 = _interopRequireDefault(_Chevron);

var _Select = require('./Select');

var _Select2 = _interopRequireDefault(_Select);

var _Pane = require('./Pane');

var _Pane2 = _interopRequireDefault(_Pane);

var _offscreenCss = require('./utils/offscreenCss');

var _offscreenCss2 = _interopRequireDefault(_offscreenCss);

var _glamor = require('glamor');

var _abbreviateNumber = require('./utils/abbreviateNumber');

var _abbreviateNumber2 = _interopRequireDefault(_abbreviateNumber);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var majorScale = _theme2.default.majorScale,
    minorScale = _theme2.default.minorScale;


var main = (0, _glamor.css)({
  display: 'inline-block',
  textAlign: 'right'
});

var size = (0, _glamor.css)({
  marginRight: majorScale(1)
});

var nav = (0, _glamor.css)({
  marginLeft: majorScale(1)
});

function PaginationButton(_ref) {
  var disabled = _ref.disabled,
      onClick = _ref.onClick,
      direction = _ref.direction,
      double = _ref.double,
      label = _ref.label;

  return _react2.default.createElement(
    _Button2.default,
    {
      size: 'small',
      disabled: disabled,
      onClick: onClick,
      paddingX: '0',
      marginLeft: minorScale(1),
      title: label
    },
    _react2.default.createElement(
      'div',
      _offscreenCss2.default,
      label
    ),
    _react2.default.createElement(_Chevron2.default, { aim: direction }),
    double && _react2.default.createElement(_Chevron2.default, { aim: direction, marginLeft: '-7px' })
  );
}
PaginationButton.displayName = 'PaginationButton';
PaginationButton.propTypes = _extends({}, _Pane2.default.propTypes, {
  disabled: _propTypes2.default.bool.isRequired,
  onClick: _propTypes2.default.func.isRequired,
  direction: _propTypes2.default.oneOf(['left', 'right']).isRequired,
  double: _propTypes2.default.bool.isRequired,
  label: _propTypes2.default.string.isRequired
});
PaginationButton.defaultProps = {
  disabled: false,
  double: false
};

var Pagination = function (_React$Component) {
  _inherits(Pagination, _React$Component);

  function Pagination() {
    _classCallCheck(this, Pagination);

    return _possibleConstructorReturn(this, (Pagination.__proto__ || Object.getPrototypeOf(Pagination)).apply(this, arguments));
  }

  _createClass(Pagination, [{
    key: 'currentPage',
    value: function currentPage() {
      var _props = this.props,
          pageSize = _props.pageSize,
          currentPageNum = _props.currentPageNum;

      return currentPageNum > -1 ? 1 + currentPageNum * pageSize : 0;
    }
  }, {
    key: 'totalPages',
    value: function totalPages() {
      var _props2 = this.props,
          pageSize = _props2.pageSize,
          currentPageNum = _props2.currentPageNum,
          totalItemCount = _props2.totalItemCount;

      return Math.min((1 + currentPageNum) * pageSize, totalItemCount);
    }
  }, {
    key: 'parseProps',
    value: function parseProps(_ref2) {
      var itemName = _ref2.itemName,
          pageSize = _ref2.pageSize,
          onPageSizeChange = _ref2.onPageSizeChange,
          totalItemCount = _ref2.totalItemCount,
          currentPageNum = _ref2.currentPageNum,
          onCurrentPageNumChange = _ref2.onCurrentPageNumChange,
          firstPageNum = _ref2.firstPageNum,
          lastPageNum = _ref2.lastPageNum,
          hidePageSizeSelect = _ref2.hidePageSizeSelect,
          props = _objectWithoutProperties(_ref2, ['itemName', 'pageSize', 'onPageSizeChange', 'totalItemCount', 'currentPageNum', 'onCurrentPageNumChange', 'firstPageNum', 'lastPageNum', 'hidePageSizeSelect']);

      return props;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          itemName = _props3.itemName,
          pageSize = _props3.pageSize,
          onPageSizeChange = _props3.onPageSizeChange,
          totalItemCount = _props3.totalItemCount,
          currentPageNum = _props3.currentPageNum,
          onCurrentPageNumChange = _props3.onCurrentPageNumChange,
          firstPageNum = _props3.firstPageNum,
          lastPageNum = _props3.lastPageNum,
          hidePageSizeSelect = _props3.hidePageSizeSelect;

      return _react2.default.createElement(
        _Pane2.default,
        _extends({}, this.parseProps(this.props), { className: '' + main }),
        !hidePageSizeSelect && _react2.default.createElement(
          'span',
          { className: '' + size },
          _react2.default.createElement(
            _Select2.default,
            {
              inline: true,
              size: 'small',
              onChange: function onChange(e) {
                return onPageSizeChange(parseInt(e.target.value, 10));
              },
              value: pageSize
            },
            _react2.default.createElement(
              'option',
              { value: '25' },
              '25'
            ),
            _react2.default.createElement(
              'option',
              { value: '50' },
              '50'
            ),
            _react2.default.createElement(
              'option',
              { value: '100' },
              '100'
            )
          )
        ),
        this.currentPage(),
        '-',
        this.totalPages(),
        ' of',
        ' ',
        (0, _abbreviateNumber2.default)(totalItemCount),
        ' ',
        (0, _pluralize2.default)(itemName, totalItemCount),
        _react2.default.createElement(
          'span',
          { className: '' + nav },
          _react2.default.createElement(PaginationButton, {
            disabled: currentPageNum <= firstPageNum,
            onClick: function onClick() {
              return onCurrentPageNumChange(firstPageNum);
            },
            direction: 'left',
            double: true,
            label: 'First page'
          }),
          _react2.default.createElement(PaginationButton, {
            disabled: currentPageNum <= firstPageNum,
            onClick: function onClick() {
              return onCurrentPageNumChange(currentPageNum - 1);
            },
            direction: 'left',
            label: 'Previous page'
          }),
          _react2.default.createElement(PaginationButton, {
            disabled: currentPageNum >= lastPageNum,
            onClick: function onClick() {
              return onCurrentPageNumChange(currentPageNum + 1);
            },
            direction: 'right',
            label: 'Next page'
          }),
          _react2.default.createElement(PaginationButton, {
            disabled: currentPageNum >= lastPageNum,
            onClick: function onClick() {
              return onCurrentPageNumChange(lastPageNum);
            },
            direction: 'right',
            double: true,
            label: 'Last page'
          })
        )
      );
    }
  }]);

  return Pagination;
}(_react2.default.Component);

exports.default = Pagination;

Pagination.displayName = 'Pagination';
Pagination.propTypes = {
  itemName: _propTypes2.default.string.isRequired,
  pageSize: _propTypes2.default.number.isRequired,
  onPageSizeChange: _propTypes2.default.func,
  totalItemCount: _propTypes2.default.number.isRequired,
  currentPageNum: _propTypes2.default.number.isRequired,
  onCurrentPageNumChange: _propTypes2.default.func.isRequired,
  firstPageNum: _propTypes2.default.number.isRequired,
  lastPageNum: _propTypes2.default.number.isRequired,
  hidePageSizeSelect: _propTypes2.default.bool
};