'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _glamor = require('glamor');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Box = require('./Box');

var _Box2 = _interopRequireDefault(_Box);

var _SearchIcon = require('./SearchIcon');

var _SearchIcon2 = _interopRequireDefault(_SearchIcon);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

var _splitProps2 = require('./utils/splitProps');

var _splitProps3 = _interopRequireDefault(_splitProps2);

var _evergreenSharedStyles = require('evergreen-shared-styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var minorScale = _theme2.default.minorScale,
    majorScale = _theme2.default.majorScale,
    textColors = _theme2.default.textColors;


var styles = (0, _glamor.css)(_evergreenSharedStyles.InputAppearances.default);

function useControlSizes(_ref) {
  var size = _ref.size,
      props = _objectWithoutProperties(_ref, ['size']);

  var sizes = _theme2.default.controlSizes[size];

  return _extends({
    minHeight: sizes.minHeight,
    minWidth: sizes.minWidth,
    textStyle: sizes.textStyle,
    paddingX: size === 'small' ? minorScale(3) : majorScale(2),
    paddingLeft: size === 'small' ? majorScale(4) : minorScale(9)
  }, props);
}

var SearchInput = function SearchInput(_ref2) {
  var className = _ref2.className,
      props = _objectWithoutProperties(_ref2, ['className']);

  // Tries to treat this component as a single box
  var _splitProps = (0, _splitProps3.default)(useControlSizes(props), /margin|width|height|display|flex|alignItems|justifyContent|flexDirection|flexGrow|flexShrink/gi),
      matchedProps = _splitProps.matchedProps,
      unmatchedProps = _splitProps.unmatchedProps;

  return _react2.default.createElement(
    _Box2.default,
    _extends({ position: 'relative', display: 'flex' }, matchedProps),
    _react2.default.createElement(_SearchIcon2.default, {
      size: 'small',
      position: 'absolute',
      top: '50%',
      marginLeft: props.size === 'small' ? minorScale(2) : minorScale(3),
      marginTop: majorScale(-1),
      fill: textColors.muted,
      style: {
        zIndex: 4,
        pointerEvents: 'none'
      }
    }),
    _react2.default.createElement(_Box2.default, _extends({
      is: 'input',
      className: (0, _classnames2.default)('' + styles, className),
      flex: '1',
      rounded: true
    }, unmatchedProps))
  );
};

SearchInput.propTypes = _extends({}, _Box2.default.propTypes, {
  size: _propTypes2.default.oneOf(Object.keys(_theme2.default.controlSizes))
});

SearchInput.defaultProps = {
  size: 'default'
};

SearchInput.displayName = 'SearchInput';

exports.default = SearchInput;