'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _glamor = require('glamor');

var _Box = require('./Box');

var _Box2 = _interopRequireDefault(_Box);

var _Pane = require('./Pane');

var _Pane2 = _interopRequireDefault(_Pane);

var _Overlay = require('./Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

var _Close = require('./Close');

var _Close2 = _interopRequireDefault(_Close);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var majorScale = _theme2.default.majorScale;


var rotate360InAnimation = _glamor.css.keyframes('rotate360InAnimation', {
  from: {
    transform: 'translateX(100%) rotate(0deg)'
  },
  to: {
    transform: 'translateX(-100%) rotate(-360deg)'
  }
});

var rotate360OutAnimation = _glamor.css.keyframes('rotate360OutAnimation', {
  from: {
    transform: 'translateX(-100%) rotate(0deg)'
  },
  to: {
    transform: 'translateX(100%) rotate(360deg)'
  }
});

var SheetClose = function SheetClose(_ref) {
  var isClosing = _ref.isClosing,
      props = _objectWithoutProperties(_ref, ['isClosing']);

  return _react2.default.createElement(
    _Box2.default,
    _extends({}, (0, _glamor.css)({
      cursor: 'pointer',
      transform: 'translateX(-100%)',
      backgroundColor: 'rgba(255, 255, 255, 0.4)',
      transition: 'background-color ' + _theme2.default.animationDuration.fast,
      animation: (isClosing ? rotate360OutAnimation : rotate360InAnimation) + ' ' + _theme2.default.animationDuration.slow + ' ' + _theme2.default.animationEasing.deceleration,
      '&:hover': {
        backgroundColor: 'rgba(255, 255, 255, 0.6)'
      },
      '&:active': {
        backgroundColor: 'rgba(255, 255, 255, 0.4)'
      }
    }), props),
    _react2.default.createElement(_Close2.default, { fill: '#fff', display: 'block' })
  );
};

SheetClose.defaultProps = {
  position: 'absolute',
  marginLeft: majorScale(-2),
  marginTop: majorScale(2),
  padding: majorScale(1),
  circle: true
};

var slideInAnimation = _glamor.css.keyframes('slideInAnimation', {
  from: {
    transform: 'translateX(100%)'
  },
  to: {
    transform: 'translateX(0)'
  }
});

var slideOutAnimation = _glamor.css.keyframes('slideOutAnimation', {
  from: {
    transform: 'translateX(0)'
  },
  to: {
    transform: 'translateX(100%)'
  }
});

var SheetPane = function SheetPane(_ref2) {
  var slideOut = _ref2.slideOut,
      props = _objectWithoutProperties(_ref2, ['slideOut']);

  return _react2.default.createElement(_Pane2.default, _extends({}, (0, _glamor.css)({
    transform: 'translateZ(0)',
    animation: (slideOut ? slideOutAnimation : slideInAnimation) + ' ' + _theme2.default.animationDuration.slow + ' ' + _theme2.default.animationEasing.deceleration
  }), props));
};

SheetPane.propTypes = {
  slideOut: _propTypes2.default.bool
};

SheetPane.defaultProps = {
  white: true,
  position: 'absolute',
  shadow: true,
  top: 0,
  right: 0,
  bottom: 0
};

SheetPane.displayName = 'SheetPane';

var Sheet = function (_Component) {
  _inherits(Sheet, _Component);

  function Sheet() {
    _classCallCheck(this, Sheet);

    var _this = _possibleConstructorReturn(this, (Sheet.__proto__ || Object.getPrototypeOf(Sheet)).call(this));

    _this.handleClose = _this.handleClose.bind(_this);
    _this.handleFadeEnd = _this.handleFadeEnd.bind(_this);

    _this.state = {
      isClosing: false
    };
    return _this;
  }

  _createClass(Sheet, [{
    key: 'handleClose',
    value: function handleClose() {
      this.setState({ isClosing: true });
    }
  }, {
    key: 'handleFadeEnd',
    value: function handleFadeEnd() {
      if (!this.state.isClosing) return;
      if (this.props.onClose) {
        this.props.onClose();
      }
      this.setState({ isClosing: false });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          isOpen = _props.isOpen,
          children = _props.children;
      var isClosing = this.state.isClosing;

      var divStyle = {
        position: 'absolute',
        left: 0,
        right: 0,
        top: 0,
        bottom: 0,
        overflow: 'auto'
      };
      if (!isOpen) return null;

      return _react2.default.createElement(
        _Overlay2.default,
        { onClick: this.handleClose, fadeOut: isClosing, onFadeEnd: this.handleFadeEnd },
        _react2.default.createElement(
          SheetPane,
          _extends({ slideOut: isClosing }, this.parseProps(this.props)),
          _react2.default.createElement(SheetClose, { isClosing: isClosing, onClick: this.handleClose }),
          _react2.default.createElement(
            'div',
            { style: divStyle },
            children
          )
        )
      );
    }
  }, {
    key: 'parseProps',
    value: function parseProps(_ref3) {
      var className = _ref3.className,
          children = _ref3.children,
          isOpen = _ref3.isOpen,
          onClose = _ref3.onClose,
          props = _objectWithoutProperties(_ref3, ['className', 'children', 'isOpen', 'onClose']);

      return props;
    }
  }]);

  return Sheet;
}(_react.Component);

Sheet.propTypes = _extends({}, _Box2.default.propTypes, {
  isOpen: _propTypes2.default.bool.isRequired,
  onClose: _propTypes2.default.func
});

Sheet.defaultProps = {
  width: majorScale(85),
  isOpen: true
};

Sheet.displayName = 'Sheet';

exports.default = Sheet;