'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SpaceType = exports.Space = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _objectValues = require('object-values');

var _objectValues2 = _interopRequireDefault(_objectValues);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var SpaceType = {
  VERTICAL: 'vertical',
  HORIZONTAL: 'horizontal'
};

var parseSpaceProps = function parseSpaceProps(_ref) {
  var step = _ref.step,
      _ref$type = _ref.type,
      type = _ref$type === undefined ? SpaceType.VERTICAL : _ref$type,
      _ref$value = _ref.value,
      value = _ref$value === undefined ? 0 : _ref$value,
      x = _ref.x,
      y = _ref.y,
      className = _ref.className,
      props = _objectWithoutProperties(_ref, ['step', 'type', 'value', 'x', 'y', 'className']);

  var style = {};

  if (x || type === SpaceType.HORIZONTAL) {
    style.display = 'inline-block';
    style.width = x;
  } else if (y || type === SpaceType.VERTICAL) {
    style.display = 'block';
    style.height = y;
  }

  return _extends({ className: (0, _classnames2.default)('Space', className), style: style }, props);
};

var Space = function Space(_ref2) {
  var _ref2$is = _ref2.is,
      is = _ref2$is === undefined ? 'div' : _ref2$is,
      props = _objectWithoutProperties(_ref2, ['is']);

  return _react2.default.createElement(is, parseSpaceProps(props));
};

Space.propTypes = {
  type: _propTypes2.default.oneOf((0, _objectValues2.default)(SpaceType)),
  is: _propTypes2.default.string,
  x: _propTypes2.default.number,
  y: _propTypes2.default.number,
  value: _propTypes2.default.number /* px value */
};

Space.displayName = 'Space';

exports.Space = Space;
exports.SpaceType = SpaceType;