'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SubNavigationBarLink = exports.SubNavigationBarTitle = exports.SubNavigationBar = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _glamor = require('glamor');

var _Pane = require('./Pane');

var _Pane2 = _interopRequireDefault(_Pane);

var _Text = require('./Text');

var _Text2 = _interopRequireDefault(_Text);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

var _Box = require('./Box');

var _Box2 = _interopRequireDefault(_Box);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var minorScale = _theme2.default.minorScale,
    majorScale = _theme2.default.majorScale;


var SubNavigationBarLink = function SubNavigationBarLink(props) {
  return _react2.default.createElement(_Link2.default, _extends({}, (0, _glamor.css)({
    '&:active, &:hover, &.active': {
      boxShadow: '0 1px ' + _theme2.default.rawColors.blue500
    }
  }), props));
};

SubNavigationBarLink.defaultProps = {
  secondary: true,
  textStyle: 'body1',
  paddingBottom: majorScale(2),
  marginX: minorScale(3)
};

var SubNavigationBarTitle = function SubNavigationBarTitle(props) {
  return _react2.default.createElement(_Text2.default, props);
};

SubNavigationBarTitle.defaultProps = {
  is: 'h2',
  textStyle: 'display4'
};

var SubNavigationBarPane = function SubNavigationBarPane(props) {
  return _react2.default.createElement(_Pane2.default, props);
};

SubNavigationBarPane.defaultProps = {
  display: 'flex',
  white: true,
  borderBottom: true
};

var SubNavigationBar = function SubNavigationBar(_ref) {
  var left = _ref.left,
      right = _ref.right,
      children = _ref.children;

  var leftChild = void 0;
  if (typeof left === 'string') {
    leftChild = _react2.default.createElement(
      SubNavigationBarTitle,
      null,
      left
    );
  } else {
    leftChild = left;
  }

  return _react2.default.createElement(
    SubNavigationBarPane,
    null,
    _react2.default.createElement(
      _Pane2.default,
      { width: '25%', padding: majorScale(2), flex: '0 0 auto' },
      leftChild
    ),
    _react2.default.createElement(
      _Pane2.default,
      { flexAuto: true, textAlign: 'center', display: 'flex', alignItems: 'flex-end', justifyContent: 'center' },
      children
    ),
    _react2.default.createElement(
      _Pane2.default,
      { width: '25%', textAlign: 'right', flex: '0 0 auto' },
      right
    )
  );
};

SubNavigationBar.propTypes = _extends({}, _Box2.default.propTypes, {
  left: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.string]),
  right: _propTypes2.default.node
});

SubNavigationBar.defaultProps = {
  theme: _theme2.default
};

exports.SubNavigationBar = SubNavigationBar;
exports.SubNavigationBarTitle = SubNavigationBarTitle;
exports.SubNavigationBarLink = SubNavigationBarLink;