'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _glamor = require('glamor');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Box = require('./Box');

var _Box2 = _interopRequireDefault(_Box);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var getMuted = function getMuted(val) {
  if (val === undefined) return '';
  switch (val) {
    case 1:
    default:
      return (0, _glamor.css)({ opacity: 0.85 });
    case 2:
      return (0, _glamor.css)({ opacity: 0.7 });
  }
};

var getColor = function getColor(_ref) {
  var white = _ref.white;

  if (white) return (0, _glamor.css)({ color: _theme2.default.colors.white });
  return '';
};

var parseProps = function parseProps(_ref2) {
  var className = _ref2.className,
      muted = _ref2.muted,
      white = _ref2.white,
      props = _objectWithoutProperties(_ref2, ['className', 'muted', 'white']);

  return _extends({
    className: (0, _classnames2.default)('' + getColor({ white: white }), '' + getMuted(muted), className)
  }, props);
};

var Text = function Text(props) {
  return _react2.default.createElement(_Box2.default, parseProps(props));
};

Text.propTypes = {
  white: _propTypes2.default.bool
};

Text.defaultProps = {
  is: 'p'
};

Text.displayName = 'Text';

exports.default = Text;