'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (ComposedComponent, spinnerProps) {
  spinnerProps = Object.assign({}, defaultSpinnerProps, spinnerProps);
  var componentName = ComposedComponent.displayName || ComposedComponent.name || 'Unknown';

  function withLoader(props) {
    return props.isLoading ? _react2.default.createElement(_Spinner2.default, spinnerProps) : _react2.default.createElement(ComposedComponent, props);
  }

  withLoader.displayName = 'withLoader(' + componentName + ')';

  withLoader.propTypes = {
    isLoading: _propTypes2.default.bool.isRequired
  };

  return withLoader;
};

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Spinner = require('./Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var majorScale = _theme2.default.majorScale;


var defaultSpinnerProps = {
  marginX: 'auto',
  marginY: majorScale(8)
};