'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseProps = exports.propTypes = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _glamor = require('glamor');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _theme = require('../components/theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = exports.propTypes = {
  background: _propTypes2.default.oneOf(Object.keys(_theme2.default.backgrounds)),
  interactive: _propTypes2.default.bool
};

var parseBackground = function parseBackground(val, interactive) {
  if (_theme2.default.backgrounds.hasOwnProperty(val)) {
    var bg = _theme2.default.backgrounds[val];
    return (0, _glamor.css)(_extends({
      color: bg.textColor,
      backgroundColor: bg.backgroundColor,
      borderColor: bg.borderColor + ' !important'
    }, interactive ? {
      '&:hover, &:active': {
        borderColor: bg.borderColorInteractive + ' !important'
      }
    } : {}));
  }
};

var parseProps = function parseProps(_ref) {
  var background = _ref.background,
      interactive = _ref.interactive,
      className = _ref.className,
      props = _objectWithoutProperties(_ref, ['background', 'interactive', 'className']);

  return _extends({
    className: background !== undefined ? (0, _classnames2.default)('' + parseBackground(background, interactive), className) : className
  }, props);
};
exports.parseProps = parseProps;