'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseProps = exports.propTypes = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _glamor = require('glamor');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _theme = require('../components/theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = exports.propTypes = {
  shadow: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.oneOf(_theme2.default.shadows.map(function (_, i) {
    return i;
  }))])
};

var parseShadow = function parseShadow(val) {
  var i = Number.isInteger(val) ? val - 1 : 0;
  return (0, _glamor.css)({
    boxShadow: _theme2.default.shadows[i]
  });
};

var parseProps = function parseProps(_ref) {
  var shadow = _ref.shadow,
      className = _ref.className,
      props = _objectWithoutProperties(_ref, ['shadow', 'className']);

  return _extends({
    className: shadow !== undefined ? (0, _classnames2.default)('' + parseShadow(shadow), className) : className
  }, props);
};
exports.parseProps = parseProps;