'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = alertStory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var minorScale = _components.theme.minorScale,
    majorScale = _components.theme.majorScale;
function alertStory(module) {
  (0, _react3.storiesOf)('Alert', module).add('usage', function () {
    return _react2.default.createElement(
      _components.App,
      { white: true },
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Alert\n\nThe Alert component is used as a feedback message. Implements the `<Box />` component.\n\n```\n<Alert>Hooray! You did it. Your Source is now sending data.</Alert>\n<Alert type=\'success\'>Hooray! You did it. Your Source is now sending data.</Alert>\n<Alert type=\'warning\'>Changes will affect all Warehouses.</Alert>\n<Alert type=\'danger\'>We weren\u2019t able to save your changes.</Alert>\n<Alert type=\'question\'>There are over 180 integrations available.</Alert>\n\n<Alert marginBottom={majorScale(2)} type=\'success\'>\n  <Display5>Hooray! You did it. Your Source is now sending data.</Display5>\n  <Body1>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</Body1>\n</Alert>\n```\n\n'
        ),
        _react2.default.createElement(
          _components.Alert,
          { marginBottom: majorScale(2) },
          'Hooray! You did it. Your Source is now sending data.'
        ),
        _react2.default.createElement(
          _components.Alert,
          { marginBottom: majorScale(2), type: 'success' },
          'Hooray! You did it. Your Source is now sending data.'
        ),
        _react2.default.createElement(
          _components.Alert,
          { marginBottom: majorScale(2), type: 'warning' },
          'Changes will affect all Warehouses.'
        ),
        _react2.default.createElement(
          _components.Alert,
          { marginBottom: majorScale(2), type: 'danger' },
          'We weren\u2019t able to save your changes.'
        ),
        _react2.default.createElement(
          _components.Alert,
          { marginBottom: majorScale(2), type: 'question' },
          'There are over 180 integrations available.'
        ),
        _react2.default.createElement(
          _components.Alert,
          { marginBottom: majorScale(2), type: 'success' },
          _react2.default.createElement(
            _components.Display5,
            null,
            'Hooray! You did it. Your Source is now sending data.'
          ),
          _react2.default.createElement(
            _components.Body1,
            null,
            'Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.'
          )
        ),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`type` | naked, success, warning, danger, question | naked | the style of Alert\n`showIcon` | bool | true | show the icon\n`showTrim` | bool | true | show the trim color on the left\n'
        )
      )
    );
  }).add('standalone', function () {
    return _react2.default.createElement(_components.Alert, null);
  }).add('with margins', function () {
    return _react2.default.createElement(
      _components.Pane,
      { white: true },
      _react2.default.createElement(_components.Alert, { margin: minorScale(3) })
    );
  }).add('with width', function () {
    return _react2.default.createElement(
      _components.Pane,
      { white: true },
      _react2.default.createElement(_components.Alert, { width: '240px', margin: minorScale(3) })
    );
  });
}