'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = avatarStory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var minorScale = _components.theme.minorScale,
    majorScale = _components.theme.majorScale;


var imageURL = 'http://www.casinomeister.com/forums/avatars/jufo.gif?dateline=1345999507';

function avatarStory(module) {
  (0, _react3.storiesOf)('Avatar', module).add('usage', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Avatar\n\nThe Avatar component allows easy avatar composition. Implements `<Box />`.\n\n* Falls back to initials on error\n* Adds a title attribute with the name\n\n```\nconst imageURL = \'' + imageURL + '\'\n\n<Avatar src={imageURL}>Segment Sloth</Avatar>\n<Avatar nameShown src=\'http://www.example.com/BAD_URL\'>Segment Sloth</Avatar>\n<Avatar src=\'https://secure.gravatar.com/avatar/01ee3e7d9562c34f5e38b338250e42ec.jpg?s=40d=blank\'>Blank Image</Avatar>\n```\n\n'
        ),
        _react2.default.createElement(
          _components.Avatar,
          { marginRight: minorScale(2), src: imageURL },
          'Segment Sloth'
        ),
        _react2.default.createElement(
          _components.Avatar,
          { nameShown: true, src: 'http://www.example.com/BAD_URL' },
          'Segment Sloth'
        ),
        _react2.default.createElement(
          _components.Avatar,
          { src: 'https://secure.gravatar.com/avatar/01ee3e7d9562c34f5e38b338250e42ec.png?s=40d=blank' },
          'Blank Image'
        ),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`children`| string | undefined | the name of the avatar/person displayed\n`imageSize`| string / small, default | 40px | the width and height of the image\n`nameShown`| boolean | false | wether to show a name under the Avatar\n'
        )
      )
    );
  }).add('with circle only', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(3), clearfix: true },
        _react2.default.createElement(
          _components.Avatar,
          { marginLeft: majorScale(1), marginRight: majorScale(1), src: imageURL },
          'Segment Sloth'
        ),
        _react2.default.createElement(
          _components.Avatar,
          { marginLeft: majorScale(1), marginRight: majorScale(1), src: 'http://www.example.com/badurl' },
          'Segment Sloth'
        )
      )
    );
  }).add('with name shown', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(3), clearfix: true },
        _react2.default.createElement(
          _components.Avatar,
          { nameShown: true, marginLeft: majorScale(1), marginRight: majorScale(1), src: imageURL },
          'Segment Sloth'
        ),
        _react2.default.createElement(
          _components.Avatar,
          { nameShown: true, marginLeft: majorScale(1), marginRight: majorScale(1), src: 'http://www.example.com/badurl' },
          'Segment Sloth'
        )
      )
    );
  }).add('with Triangle', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(3), clearfix: true },
        _react2.default.createElement(
          _components.Box,
          { display: 'flex', alignItems: 'center' },
          _react2.default.createElement(
            _components.Avatar,
            { marginLeft: majorScale(1), marginRight: majorScale(1), src: imageURL },
            'Segment Sloth'
          ),
          _react2.default.createElement(_components.Triangle, { aim: 'down', display: 'inline-flex' })
        )
      )
    );
  }).add('standalone', function () {
    return _react2.default.createElement(
      _components.Avatar,
      { marginLeft: majorScale(1), marginRight: majorScale(1), src: imageURL },
      'Segment Sloth'
    );
  });
}