'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = BottomSheetStory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var majorScale = _components.theme.majorScale;

var BottomSheetTrigger = function (_React$Component) {
  _inherits(BottomSheetTrigger, _React$Component);

  function BottomSheetTrigger() {
    _classCallCheck(this, BottomSheetTrigger);

    var _this = _possibleConstructorReturn(this, (BottomSheetTrigger.__proto__ || Object.getPrototypeOf(BottomSheetTrigger)).call(this));

    _this.toggle = _this.toggle.bind(_this);
    _this.state = {
      isOpen: false
    };
    return _this;
  }

  _createClass(BottomSheetTrigger, [{
    key: 'toggle',
    value: function toggle() {
      this.setState({ isOpen: !this.state.isOpen });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _components.Pane,
        null,
        _react2.default.createElement(
          _components.Button,
          { primary: true, onClick: this.toggle },
          'Open BottomSheet'
        ),
        _react2.default.createElement(
          _components.BottomSheet,
          {
            title: 'Sheet Title',
            side: this.props.side, isOpen: this.state.isOpen, onClose: this.toggle },
          _react2.default.createElement(
            _components.Pane,
            { padding: majorScale(2), height: '800px' },
            'Hello World'
          )
        )
      );
    }
  }]);

  return BottomSheetTrigger;
}(_react2.default.Component);

function BottomSheetStory(module) {
  (0, _react3.storiesOf)('Bottom Sheet', module).add('usage', function () {
    return _react2.default.createElement(
      _components.App,
      { white: true },
      _react2.default.createElement(
        _components.Pane,
        { padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Bottom Sheet\n\nThe BottomSheet component. Implement the `<Pane />` component.\n* TODO: padding top is hardcoded to 62px for content\n\n```\nclass BottomSheetTrigger extends React.Component {\n  constructor() {\n    super()\n    this.toggle = this.toggle.bind(this)\n    this.state = {\n      isOpen: false\n    }\n  }\n\n  toggle() {\n    this.setState({ isOpen: !this.state.isOpen })\n  }\n\n  render() {\n    return (\n      <Pane>\n        <Button primary onClick={this.toggle}>Open BottomSheet</Button>\n        <BottomSheet\n          title=\'Sheet Title\'\n          side={this.props.side} isOpen={this.state.isOpen} onClose={this.toggle}>\n          <Pane padding={majorScale(2)} height=\'800px\'>Hello World</Pane>\n        </BottomSheet>\n      </Pane>\n    )\n  }\n}\n\n<BottomSheetTrigger />\n```\n\n'
        ),
        _react2.default.createElement(BottomSheetTrigger, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`isOpen` | boolean | undefined | is the BottomSheet open\n`onClose` | function | undefined | onClose handler to manage state\n`title` | string/node | undefined | gets title styling when string\n`navigationBarLeft` | node | `<BottomSheetCloseButton />` | gets a close handler on the fly\n`navigationBarRight` | node | undefined | right of navigation bar\n'
        )
      )
    );
  }).add('plain', function () {
    return _react2.default.createElement(
      _components.App,
      { padding: majorScale(2) },
      _react2.default.createElement(BottomSheetTrigger, null)
    );
  }).add('standalone', function () {
    return _react2.default.createElement(BottomSheetTrigger, null);
  });
}