'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = codeBlockStory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var majorScale = _components.theme.majorScale;
function codeBlockStory(module) {
  (0, _react3.storiesOf)('Code Block', module).add('usage', function () {
    return _react2.default.createElement(
      _components.App,
      { white: true },
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Code Block\n\nThe CodeBlock component is a syntax highlighted block wrapped in a configured Pane.\n`props` apply to Pane except for `language` and `codeStyle`.\n\n* Uses [react-syntax-highlighter](https://github.com/conorhastings/react-syntax-highlighter)\n* Always wrap code in a string literal for safety\n* Always escape the content\n\n```\n<CodeBlock language=\'html\'>\n  {`<script>\r\n  !function(){var analytics=window.analytics=window.analytics||[];if(!analytics.initialize)if(analytics.invoked)window.console&&console.error&&console.error("Segment snippet included twice.");else{analytics.invoked=!0;analytics.methods=["trackSubmit","trackClick","trackLink","trackForm","pageview","identify","reset","group","track","ready","alias","debug","page","once","off","on"];analytics.factory=function(t){return function(){var e=Array.prototype.slice.call(arguments);e.unshift(t);analytics.push(e);return analytics}};for(var t=0;t<analytics.methods.length;t++){var e=analytics.methods[t];analytics[e]=analytics.factory(e)}analytics.load=function(t){var e=document.createElement("script");e.type="text/javascript";e.async=!0;e.src=("https:"===document.location.protocol?"https://":"http://")+"cdn.segment.com/analytics.js/v1/"+t+"/analytics.min.js";var n=document.getElementsByTagName("script")[0];n.parentNode.insertBefore(e,n)};analytics.SNIPPET_VERSION="4.0.0";\r\n  analytics.load("YOUR_WRITE_KEY");\r\n  analytics.page();\r\n  }}();\r\n</script>`}\n</CodeBlock>\n```\n\n'
        ),
        _react2.default.createElement(
          _components.CodeBlock,
          { language: 'html' },
          '<script>\r\n  !function(){var analytics=window.analytics=window.analytics||[];if(!analytics.initialize)if(analytics.invoked)window.console&&console.error&&console.error("Segment snippet included twice.");else{analytics.invoked=!0;analytics.methods=["trackSubmit","trackClick","trackLink","trackForm","pageview","identify","reset","group","track","ready","alias","debug","page","once","off","on"];analytics.factory=function(t){return function(){var e=Array.prototype.slice.call(arguments);e.unshift(t);analytics.push(e);return analytics}};for(var t=0;t<analytics.methods.length;t++){var e=analytics.methods[t];analytics[e]=analytics.factory(e)}analytics.load=function(t){var e=document.createElement("script");e.type="text/javascript";e.async=!0;e.src=("https:"===document.location.protocol?"https://":"http://")+"cdn.segment.com/analytics.js/v1/"+t+"/analytics.min.js";var n=document.getElementsByTagName("script")[0];n.parentNode.insertBefore(e,n)};analytics.SNIPPET_VERSION="4.0.0";\r\n  analytics.load("YOUR_WRITE_KEY");\r\n  analytics.page();\r\n  }}();\r\n</script>'
        ),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`language` | string | javascript | syntax highlighting\n`codeStyle` | object | `segmentStyle` | the styles used for highlighting\n'
        )
      )
    );
  }).add('standalone', function () {
    return _react2.default.createElement(
      _components.CodeBlock,
      { language: 'html' },
      '<script type="text/javascript">\r\n  !function(){var analytics=window.analytics=window.analytics||[];if(!analytics.initialize)if(analytics.invoked)window.console&&console.error&&console.error("Segment snippet included twice.");else{analytics.invoked=!0;analytics.methods=["trackSubmit","trackClick","trackLink","trackForm","pageview","identify","reset","group","track","ready","alias","debug","page","once","off","on"];analytics.factory=function(t){return function(){var e=Array.prototype.slice.call(arguments);e.unshift(t);analytics.push(e);return analytics}};for(var t=0;t<analytics.methods.length;t++){var e=analytics.methods[t];analytics[e]=analytics.factory(e)}analytics.load=function(t){var e=document.createElement("script");e.type="text/javascript";e.async=!0;e.src=("https:"===document.location.protocol?"https://":"http://")+"cdn.segment.com/analytics.js/v1/"+t+"/analytics.min.js";var n=document.getElementsByTagName("script")[0];n.parentNode.insertBefore(e,n)};analytics.SNIPPET_VERSION="4.0.0";\r\n  analytics.load("YOUR_WRITE_KEY");\r\n  analytics.page();\r\n  }}();\r\n</script>'
    );
  });
}