'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = iconsStory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var majorScale = _components.theme.majorScale;


var Docs = function Docs() {
  return _react2.default.createElement(
    _Content2.default,
    { markdown: true },
    '\nprop | type | default | description\n-----|------| --------|-------------\n`aim`| up/top, right, down/bottom, left | right | the direction the icon is aiming\n`size` | mini, small, big | mini | the size of the icon\n`fill` | string | dark text color | the fill of the icon\n'
  );
};

function iconsStory(module) {
  (0, _react3.storiesOf)('Icons', module).add('Archive', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Archive\n\nImplements `<Box />`.\n\n```\n<ArchiveIcon />\n```\n\n'
        ),
        _react2.default.createElement(_components.ArchiveIcon, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n  prop | type | default | description\n  -----|------| --------|-------------\n  `size` | mini, small, big | mini | the size of the icon\n  `fill` | string | text color | the fill of the icon\n          '
        )
      )
    );
  }).add('Arrow', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Arrow\n\nThe Arrow icon is a multi purpose directional icon. Implements `<Box />`.\n\n```\n<Arrow aim=\'up\' />\n<Arrow aim=\'right\' />\n<Arrow aim=\'down\' />\n<Arrow aim=\'left\' />\n```\n\n'
        ),
        _react2.default.createElement(_components.Arrow, { aim: 'up' }),
        _react2.default.createElement(_components.Arrow, { aim: 'right' }),
        _react2.default.createElement(_components.Arrow, { aim: 'down' }),
        _react2.default.createElement(_components.Arrow, { aim: 'left' }),
        _react2.default.createElement(Docs, null)
      )
    );
  }).add('Check Circle', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Check Circle\n\nThe CheckCircle icon is an icon for check marks in the UI. Implements `<Box />`.\n\n```\n<CheckCircle />\n```\n\n'
        ),
        _react2.default.createElement(_components.CheckCircle, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`size` | mini, small, big | mini | the size of the icon\n`fill` | string | green | the fill of the icon\n          '
        )
      )
    );
  }).add('Chevron', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Chevron\n\nThe Chevron icon is a multi purpose directional icon. Implements `<Box />`.\n\n```\n<Chevron aim=\'up\' />\n<Chevron aim=\'right\' />\n<Chevron aim=\'down\' />\n<Chevron aim=\'left\' />\n```\n\n'
        ),
        _react2.default.createElement(_components.Chevron, { aim: 'up' }),
        _react2.default.createElement(_components.Chevron, { aim: 'right' }),
        _react2.default.createElement(_components.Chevron, { aim: 'down' }),
        _react2.default.createElement(_components.Chevron, { aim: 'left' }),
        _react2.default.createElement(Docs, null)
      )
    );
  }).add('Close', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Close\n\nThe Close icon is a base for close buttons. Implements `<Box />`.\n\n```\n<Close />\n```\n\n'
        ),
        _react2.default.createElement(_components.Close, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`size` | mini, small, big | mini | the size of the icon\n`fill` | string | dark text color | the fill of the icon\n          '
        )
      )
    );
  }).add('Cog', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Cog\n\nThe Cog icon is often used settings. Implements `<Box />`.\n\n```\n<CogIcon />\n```\n\n'
        ),
        _react2.default.createElement(_components.CogIcon, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`size` | mini, small, big | small | the size of the icon\n`fill` | string | text color | the fill of the icon\n          '
        )
      )
    );
  }).add('Double Triangle', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Double Triangle\n\nThe DoubleTriangle icon is a icon for select\'s. Implements `<Box />`.\n\n```\n<DoubleTriangle />\n```\n\n'
        ),
        _react2.default.createElement(_components.DoubleTriangle, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`size` | mini, small, big | mini | the size of the icon\n`fill` | string | dark text color | the fill of the icon\n          '
        )
      )
    );
  }).add('Exclamation Circle', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Exclamation Circle\n\nThe ExclamationCircle icon is a icon for input warnings. Implements `<Box />`.\n\n```\n<ExclamationCircle />\n```\n\n'
        ),
        _react2.default.createElement(_components.ExclamationCircle, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`size` | mini, small, big | mini | the size of the icon\n`fill` | string | dark text color | the fill of the icon\n          '
        )
      )
    );
  }).add('Filter', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Filter\n\nThe Filter icon is often used for showing/hiding filtering controls. Implements `<Box />`.\n\n```\n<FilterIcon />\n```\n\n'
        ),
        _react2.default.createElement(_components.FilterIcon, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`size` | mini, small, big | small | the size of the icon\n`fill` | string | text color | the fill of the icon\n          '
        )
      )
    );
  }).add('Help', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Help\n\nThe Help icon is often used as a trigger for tooltips. Implements `<Box />`.\n\n```\n<HelpIcon />\n```\n\n'
        ),
        _react2.default.createElement(_components.HelpIcon, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`size` | mini, small, big | small | the size of the icon\n`fill` | string | text color | the fill of the icon\n          '
        )
      )
    );
  }).add('Plus Circle', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Plus Circle\n\nThe Plus Circle icon is often used for in an add button. Implements `<Box />`.\n\n```\n<PlusCircleIcon />\n```\n\n'
        ),
        _react2.default.createElement(_components.PlusCircleIcon, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`size` | mini, small, big | small | the size of the icon\n`fill` | string | text color | the fill of the icon\n          '
        )
      )
    );
  }).add('Search', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Search\n\nThe Search icon is an icon for search inputs in the UI. Implements `<Box />`.\n\n```\n<SearchIcon />\n```\n\n'
        ),
        _react2.default.createElement(_components.SearchIcon, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`size` | mini, small, big | mini | the size of the icon\n`fill` | string | text color | the fill of the icon\n          '
        )
      )
    );
  }).add('Drag', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Drag\n\nThe Drag icon is an icon for draggable elements in the UI. Implements `<Box />`.\n\n```\n<DragIcon />\n```\n\n'
        ),
        _react2.default.createElement(_components.DragIcon, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`size` | mini, small, big | small | the size of the icon\n`stroke` | string | text color | the stroke color of the icon\n          '
        )
      )
    );
  }).add('Triangle', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Triangle\n\nThe Triangle icon is a multi purpose directional icon. Implements `<Box />`.\n\n```\n<Triangle aim=\'up\' />\n<Triangle aim=\'right\' />\n<Triangle aim=\'down\' />\n<Triangle aim=\'left\' />\n<Triangle aim=\'right\' transform=\'translateY(-50%)\' />\n```\n\n'
        ),
        _react2.default.createElement(_components.Triangle, { aim: 'up' }),
        _react2.default.createElement(_components.Triangle, { aim: 'right' }),
        _react2.default.createElement(_components.Triangle, { aim: 'down' }),
        _react2.default.createElement(_components.Triangle, { aim: 'left' }),
        _react2.default.createElement(_components.Triangle, { aim: 'right', transform: 'translateY(-50%)' }),
        _react2.default.createElement(Docs, null)
      )
    );
  }).add('Unarchive', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Unarchive\n\nImplements `<Box />`.\n\n```\n<ArchiveIcon />\n```\n\n'
        ),
        _react2.default.createElement(_components.UnarchiveIcon, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n  prop | type | default | description\n  -----|------| --------|-------------\n  `size` | mini, small, big | mini | the size of the icon\n  `fill` | string | text color | the fill of the icon\n          '
        )
      )
    );
  }).add('Danger Alert', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Danger Alert\n\nThe Danger Alert Icon is used in the `<Alert type=\'danger\' />` component.\n\nImplements `<Box />`.\n\n```\n<DangerAlertIcon />\n```\n\n'
        ),
        _react2.default.createElement(_components.DangerAlertIcon, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`size` | mini, small, big | small | the size of the icon\n`fill` | string | danger color | the fill of the icon\n          '
        )
      )
    );
  }).add('Question Alert', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Question Alert\n\nThe Question Alert Icon is used in the `<Alert type=\'question\' />` component.\n\nImplements `<Box />`.\n\n```\n<QuestionAlertIcon />\n```\n\n'
        ),
        _react2.default.createElement(_components.QuestionAlertIcon, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`size` | mini, small, big | small | the size of the icon\n`fill` | string | question color | the fill of the icon\n          '
        )
      )
    );
  }).add('Success Alert', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Success Alert\n\nThe Success Alert Icon is used in the `<Alert type=\'success\' />` component.\n\nImplements `<Box />`.\n\n```\n<SuccessAlertIcon />\n```\n\n'
        ),
        _react2.default.createElement(_components.SuccessAlertIcon, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`size` | mini, small, big | small | the size of the icon\n`fill` | string | success color | the fill of the icon\n          '
        )
      )
    );
  }).add('Warning Alert', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Warning Alert\n\nThe Warning Alert Icon is used in the `<Alert type=\'warning\' />` component.\n\nImplements `<Box />`.\n\n```\n<WarningAlertIcon />\n```\n\n'
        ),
        _react2.default.createElement(_components.WarningAlertIcon, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`size` | mini, small, big | small | the size of the icon\n`fill` | string | warning color | the fill of the icon\n          '
        )
      )
    );
  });
}