'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = inputStory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var minorScale = _components.theme.minorScale,
    majorScale = _components.theme.majorScale;
function inputStory(module) {
  (0, _react3.storiesOf)('Input', module).add('usage', function () {
    return _react2.default.createElement(
      _components.App,
      { white: true },
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Input\n\nThe Input component is an `input` element. Implement the `<Box />` component.\n\n```\n<Input placeholder=\'Let us know why\' marginY={majorScale(2)} />\n<Input warning placeholder=\'Let us know why\' marginY={majorScale(2)} />\n\n<Input size=\'small\' placeholder=\'Let us know why\' marginY={majorScale(2)} />\n<Input size=\'small\' warning placeholder=\'Let us know why\' marginY={majorScale(2)} />\n\n<Input disabled placeholder=\'Let us know why\' marginY={majorScale(2)} />\n```\n\n'
        ),
        _react2.default.createElement(
          _components.Display4,
          { marginRight: majorScale(1), marginY: majorScale(2) },
          'Default'
        ),
        _react2.default.createElement(_components.Input, { placeholder: 'Let us know why', marginY: majorScale(2) }),
        _react2.default.createElement(_components.Input, { warning: true, placeholder: 'Let us know why', marginY: majorScale(2) }),
        _react2.default.createElement(
          _components.Display4,
          { marginRight: majorScale(1), marginY: majorScale(2) },
          'Small'
        ),
        _react2.default.createElement(_components.Input, { size: 'small', placeholder: 'Let us know why', marginY: majorScale(2) }),
        _react2.default.createElement(_components.Input, { size: 'small', warning: true, placeholder: 'Let us know why', marginY: majorScale(2) }),
        _react2.default.createElement(
          _components.Display4,
          { marginRight: majorScale(1), marginY: majorScale(2) },
          'Disabled'
        ),
        _react2.default.createElement(_components.Input, { disabled: true, placeholder: 'Let us know why', marginY: majorScale(2) }),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | version | type | default | description\n-----|---------|------| --------|-------------\n`size`| v3.0.0 | `default`, `small` | `default` | as defined by `theme.controlSizes`\n`warning` | v2 | boolean | undefined | toggles `<ExclamationCircle />` on the side\n'
        )
      )
    );
  }).add('standalone', function () {
    return _react2.default.createElement(_components.Input, null);
  }).add('with margins', function () {
    return _react2.default.createElement(
      _components.Pane,
      { white: true },
      _react2.default.createElement(_components.Input, { margin: minorScale(3) })
    );
  }).add('with width', function () {
    return _react2.default.createElement(
      _components.Pane,
      { white: true },
      _react2.default.createElement(_components.Input, { width: '240px', margin: minorScale(3) })
    );
  });
}