'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = inputStory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var minorScale = _components.theme.minorScale,
    majorScale = _components.theme.majorScale;
function inputStory(module) {
  (0, _react3.storiesOf)('Search Input', module).add('usage', function () {
    return _react2.default.createElement(
      _components.App,
      { white: true },
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# SearchInput\n\nThe SearchInput component is an `input` element. Implement the `<Box />` component.\n\n```\n<SearchInput marginY={majorScale(2)} placeholder=\'Type to search\u2026\' />\n<SearchInput size=\'small\' marginY={majorScale(2)} placeholder=\'Type to search\u2026\' />\n<SearchInput disabled marginY={majorScale(2)} placeholder=\'Type to search\u2026\' />\n```\n\n'
        ),
        _react2.default.createElement(_components.SearchInput, { marginY: majorScale(2), placeholder: 'Type to search\u2026' }),
        _react2.default.createElement(_components.SearchInput, { size: 'small', marginY: majorScale(2), placeholder: 'Type to search\u2026' }),
        _react2.default.createElement(_components.SearchInput, { disabled: true, marginY: majorScale(2), placeholder: 'Type to search\u2026' })
      )
    );
  }).add('standalone', function () {
    return _react2.default.createElement(_components.SearchInput, null);
  }).add('with spacing', function () {
    return _react2.default.createElement(
      _components.Pane,
      { white: true },
      _react2.default.createElement(_components.SearchInput, { margin: minorScale(3) })
    );
  }).add('with width and centered', function () {
    return _react2.default.createElement(
      _components.Pane,
      { white: true },
      _react2.default.createElement(_components.SearchInput, { width: '240px', marginX: 'auto', marginY: minorScale(3) })
    );
  });
}