'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = textStory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var majorScale = _components.theme.majorScale;
function textStory(module) {
  (0, _react3.storiesOf)('Text', module).add('usage', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Text\n\nThe Text component is a `p` by default. Implements Box.\n\n## Use our predefined text components\n\n```\n<Display1>Display1</Display1>\n<Display2>Display2</Display2>\n<Display3>Display3</Display3>\n<Display4>Display4</Display4>\n<Display5>Display5</Display5>\n<Body1>Body1</Body1>\n<Body2>Body2</Body2>\n<Caps1>Caps1</Caps1>\n<Caps2>Caps2</Caps2>\n```\n\n'
        ),
        _react2.default.createElement(
          _components.Display1,
          null,
          'Display1'
        ),
        _react2.default.createElement(
          _components.Display2,
          null,
          'Display2'
        ),
        _react2.default.createElement(
          _components.Display3,
          null,
          'Display3'
        ),
        _react2.default.createElement(
          _components.Display4,
          null,
          'Display4'
        ),
        _react2.default.createElement(
          _components.Display5,
          null,
          'Display5'
        ),
        _react2.default.createElement(
          _components.Body1,
          null,
          'Body1'
        ),
        _react2.default.createElement(
          _components.Body2,
          null,
          'Body2'
        ),
        _react2.default.createElement(
          _components.Caps1,
          null,
          'Caps1'
        ),
        _react2.default.createElement(
          _components.Caps2,
          null,
          'Caps2'
        ),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n\n## Using the Text component directly\n\nYou can use the Text component directly, but it needs to be configured with a textColor and sometimes a different semantic element.\nBelow is essentially the same as using the components described above.\n\n```\n<Text is="h2" textColor="title" textStyle=\'display1\'>Display (1)</Text>\n<Text is="h2" textColor="title" textStyle=\'display2\'>Display 2</Text>\n<Text is="h2" textColor="title" textStyle=\'display3\'>Display 3</Text>\n<Text is="h2" textColor="title" textStyle=\'display4\'>Display 4</Text>\n<Text is="h2" textColor="title" textStyle=\'display5\'>Display 5</Text>\n<Text textColor="body" textStyle=\'body1\'>Body (1)</Text>\n<Text textColor="body" textStyle=\'body2\'>Body 2</Text>\n<Text textColor="body" textStyle=\'mono\'>Mono</Text>\n<Text textColor="body" textStyle=\'caps1\'>Caps 1</Text>\n<Text textColor="body" textStyle=\'caps2\'>Caps 2</Text>\n```\n\n'
        ),
        _react2.default.createElement(
          _components.Text,
          { is: 'h2', textColor: 'title', textStyle: 'display1' },
          'Display (1)'
        ),
        _react2.default.createElement(
          _components.Text,
          { is: 'h2', textColor: 'title', textStyle: 'display2' },
          'Display 2'
        ),
        _react2.default.createElement(
          _components.Text,
          { is: 'h2', textColor: 'title', textStyle: 'display3' },
          'Display 3'
        ),
        _react2.default.createElement(
          _components.Text,
          { is: 'h2', textColor: 'title', textStyle: 'display4' },
          'Display 4'
        ),
        _react2.default.createElement(
          _components.Text,
          { is: 'h2', textColor: 'title', textStyle: 'display5' },
          'Display 5'
        ),
        _react2.default.createElement(
          _components.Text,
          { textColor: 'body', textStyle: 'body1' },
          'Body (1)'
        ),
        _react2.default.createElement(
          _components.Text,
          { textColor: 'body', textStyle: 'body2' },
          'Body 2'
        ),
        _react2.default.createElement(
          _components.Text,
          { textColor: 'body', textStyle: 'mono' },
          'Mono'
        ),
        _react2.default.createElement(
          _components.Text,
          { textColor: 'body', textStyle: 'caps1' },
          'Caps 1'
        ),
        _react2.default.createElement(
          _components.Text,
          { textColor: 'body', textStyle: 'caps2' },
          'Caps 2'
        ),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n\n## Text Styles API\n\nListed as a reference. Is not unique to `<Text />`, but is implemented on Box.\n\nprop | type | description\n-----|------|------------\n`textStyle` | display1, display2, display3, display4, body1, body2, mono, caps1, caps2 | use text style\n`textColor` | title, body, muted, white | use text color\n'
        )
      )
    );
  }).add('Truncate Text', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        'div',
        { style: { width: 240 } },
        _react2.default.createElement(
          _components.Text,
          { textStyle: 'body1', truncate: true },
          'Truncate Text when it gets too long lorem ipsum'
        )
      )
    );
  }).add('Muted (1) Text', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Text,
        { muted: true },
        'Soft Mute your text: ',
        _react2.default.createElement(
          _components.Code,
          null,
          '<Text muted>...</Text>'
        )
      )
    );
  }).add('Muted 2 Text', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Text,
        { muted: 2 },
        'Mute your text even more: ',
        _react2.default.createElement(
          _components.Code,
          null,
          '<Text muted={2}>...</Text>'
        )
      )
    );
  }).add('standalone', function () {
    return _react2.default.createElement(
      _components.Text,
      { muted: 2 },
      'Mute your text even more: ',
      _react2.default.createElement(
        _components.Code,
        null,
        '<Text muted={2}>...</Text>'
      )
    );
  });
}